=== tests/anbox/android/CMakeLists.txt ===
ANBOX_ADD_TEST(intent_tests intent_tests.cpp)
