=== tests/anbox/container/CMakeLists.txt ===
ANBOX_ADD_TEST(lxc_container_tests lxc_container_tests.cpp)
