=== tests/anbox/support/CMakeLists.txt ===
ANBOX_ADD_TEST(at_parser_tests at_parser_tests.cpp)
