=== external/android-emugl/host/tools/CMakeLists.txt ===
add_subdirectory(emugen)
