=== src/CMakeLists.txt ===
--- 
+++ 
@@ -204,6 +204,8 @@
     anbox/graphics/multi_window_composer_strategy.h
     anbox/graphics/opengles_message_processor.cpp
     anbox/graphics/opengles_message_processor.h
+    anbox/graphics/opengles_socket_connection.cpp
+    anbox/graphics/opengles_socket_connection.h
     anbox/graphics/primitives.h
     anbox/graphics/program_family.cpp
     anbox/graphics/program_family.h
@@ -327,8 +329,3 @@
     anbox/qemu/qemud_message_processor.cpp
     anbox/qemu/qemud_message_processor.h
     anbox/qemu/sensors_message_processor.cpp
-    anbox/qemu/sensors_message_processor.h
-
-    anbox/rpc/channel.cpp
-    anbox/rpc/channel.h
-    anbox/rpc/connection_creator.cpp
