=== android/opengl/shared/OpenglCodecCommon/Makefile ===

ROOT=../..

include $(ROOT)/make/commondefs

CXXFILES = TcpStream.cpp GLClientState.cpp glUtils.cpp
CXXINCS += -I$(ROOT)/libs/GLESv1 -I$(ROOT)/include

LIBRARY_NAME = libcodecCommon.a

include $(COMMONRULES)
