=== debian/changelog ===
anbox (0.0~git20211020-3) unstable; urgency=medium

  * Use debhelper to install systemd service properly (Closes: #1010562)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 04 May 2022 20:32:15 +0800

anbox (0.0~git20211020-2) unstable; urgency=medium

  * Rebuild with sdbus-cpp 1.1.0

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 10 Feb 2022 10:39:26 +0800

anbox (0.0~git20211020-1) unstable; urgency=medium

  * New upstream snapshot.
    Fix build with GCC 11. (Closes: #999624)
  * Install anbox dbus service

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 14 Nov 2021 22:47:19 +0800

anbox (0.0~git20210625-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add libsdbus-c++-bin to Build-Depends
  * Backport patch for lxc >= 4.0.9
  * Update Standards-Version to 4.6.0 (no changes)
  * Add cmake-extras to Build-Depends
  * Move systemd service to /usr/lib/systemd/system/
  * Fix desktop file name in menu

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 01 Sep 2021 03:43:32 +0800
