=== debian/rules ===
--- 
+++ 
@@ -36,3 +36,9 @@
 
 override_dh_gencontrol:
 	dh_gencontrol -- $(EXTRA_SUBSTVARS)
+
+override_dh_installsystemd:
+	dh_installsystemd --name=anbox-container-manager
+
+override_dh_installsystemduser:
+	dh_installsystemduser --name=anbox-session-manager
